#include "stdafx.h"
#include <windows.h>
#include "resource.h"
#include <mmeapi.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>

#define TITLE 	TEXT("Long time recorder")
#define SRATE 	11025

/********************************************************************************/
/*		Spawn																	*/
/********************************************************************************/
void Spawn(char *commandline)
{
   	STARTUPINFO lpStartInfo;
    int fSuccess;
    HANDLE hProcess;
    PROCESS_INFORMATION lpProcessInfo;
    int rc;
    ZeroMemory(&lpStartInfo,sizeof(lpStartInfo));
    lpStartInfo.cb=sizeof(lpStartInfo);
    lpStartInfo.dwFlags=   STARTF_USESHOWWINDOW;
    lpStartInfo.wShowWindow=  SW_HIDE;
    fSuccess=CreateProcess(NULL, commandline,NULL,
		     NULL,true,0,NULL,NULL,&lpStartInfo,&lpProcessInfo);
    if (fSuccess){
	 	hProcess=lpProcessInfo.hProcess;

            // svȃXbhnhN[Y
	 	CloseHandle(lpProcessInfo.hThread);
	    //vZXI܂ő҂
	 	rc=WaitForSingleObject(hProcess,INFINITE);
		if((unsigned int)rc==WAIT_FAILED)
	  		exit(1);
    }
    else
    	exit(1);
//    return  hProcess;
}
/********************************************************************************/
/*		output_file																*/
/********************************************************************************/
struct wave_header{
	char RIFF[4];						// "RIFF"
	int RIFF_size;						// file size - 8  data byte + 44 -8
	char format[4];						// "WAVE"
	char fmt[4];						// "fmt "
	int fmt_byte;						// 0x10  format ̃oCg
	short voice_fmt;					// 0x01: jAPCM
	short channel;						// 0x01
	int freq;							// 10000
	int byte_sec;						// 20000
	short block_byte;					// 0x02  oCg/Tv*`l
	short bit_sample;					// 0x10  1Tv 16rbg
	char data[4];						// "data"
	int data_byte;
//	short data[];
};

struct wave_header wave_header={
	'R','I','F','F',
	0,						// data byte + 36
	'W','A','V','E',
	'f','m','t',' ',
	0x10,
	1,
	1,
	44100,
	44100*2,
	2,
	0x10,
	'd','a','t','a',
	0,						// data byte
};

LPSTR oWave;
int oByte;
char output_str[512];

void output()
{
	int fd;
	char wav[1024], cmd[1024];
	
	sprintf(wav, "%s.wav", output_str);
	fd = _open(wav, O_WRONLY|O_CREAT|O_BINARY|O_TRUNC, 0777);
	if(fd < 0){
		MessageBox(0, "file open error", "", MB_OK);
		return;
	}
	wave_header.data_byte = oByte;
	_write(fd, &wave_header, sizeof(wave_header));
	_write(fd, oWave, oByte);
	_close(fd);
	
	sprintf(cmd, "lame.exe %s.wav %s.mp3", output_str, output_str);
	Spawn(cmd);
	remove(wav);
}


void output_file(WAVEHDR *whdr)
{
	int i;
	char timestr[512], datestr[512];
	DWORD id;
	
	sprintf(output_str, "%s--%s", _strdate(datestr), _strtime(timestr));
	for(i=0; output_str[i]; i++){
		if(output_str[i]=='/' || output_str[i]==':')
			output_str[i] = '-';
	}

	oByte = whdr->dwBytesRecorded;
	memcpy(oWave, whdr->lpData, oByte);
	CreateThread(0, 0, (LPTHREAD_START_ROUTINE)output, 0, 0, &id);
}
/********************************************************************************/
/*		WndProc																	*/
/********************************************************************************/
LRESULT CALLBACK WndProc(HWND hWnd , UINT msg , WPARAM wp , LPARAM lp) {
	static WAVEFORMATEX wfe;
	static HWAVEOUT hWaveOut;
	static HWAVEIN hWaveIn;
	static LPSTR bWave;
	static WAVEHDR whdr;

	switch (msg) {
	case WM_DESTROY:
		free(bWave);
		PostQuitMessage(0);
		return 0;
	case WM_CREATE:
		wfe.wFormatTag = WAVE_FORMAT_PCM;	// format type
		wfe.nChannels = 1;					// number of channels
		wfe.nSamplesPerSec = 44100;			// sample rate
		wfe.nAvgBytesPerSec = 44100*2;		// for buffer estimation
		wfe.wBitsPerSample = 16;			// bits per sample
		wfe.nBlockAlign = wfe.nChannels * wfe.wBitsPerSample / 8;	// block size of data

		whdr.dwBufferLength = wfe.nAvgBytesPerSec * 3600;

		whdr.lpData = bWave = (LPSTR)malloc(whdr.dwBufferLength);
		oWave               = (LPSTR)malloc(whdr.dwBufferLength);
		whdr.dwLoops = 1;					// loop control counter
		return 0;
	case WM_COMMAND:
		switch(LOWORD(wp)) {
		case IDB_REC:
			waveInOpen(&hWaveIn , WAVE_MAPPER , &wfe ,
				(DWORD)hWnd , 0 , CALLBACK_WINDOW);
			waveInPrepareHeader(hWaveIn , &whdr , sizeof(WAVEHDR));
			break;
//		case IDB_PLAY:
//			waveOutOpen(&hWaveOut , WAVE_MAPPER , &wfe ,
//				(DWORD)hWnd , 0 , CALLBACK_WINDOW);
//			waveOutPrepareHeader(hWaveOut , &whdr , sizeof(WAVEHDR));
//			break;
		}
		return 0;
	case MM_WIM_OPEN:
//		EnableWindow(GetDlgItem(hWnd , IDB_PLAY) , FALSE);
		EnableWindow(GetDlgItem(hWnd , IDB_REC) , FALSE);
		waveInAddBuffer(hWaveIn , &whdr , sizeof(WAVEHDR));
		waveInStart(hWaveIn);
		return 0;
	case MM_WIM_DATA:
		waveInStop(hWaveIn);
		waveInClose(hWaveIn);
		output_file(&whdr);//AAAAA
//		EnableWindow(GetDlgItem(hWnd , IDB_PLAY) , TRUE);
//		EnableWindow(GetDlgItem(hWnd , IDB_REC) , TRUE);
		return 0;
	case MM_WIM_CLOSE:
		waveInUnprepareHeader(hWaveIn , &whdr , sizeof(WAVEHDR));

		waveInOpen(&hWaveIn , WAVE_MAPPER , &wfe ,
			(DWORD)hWnd , 0 , CALLBACK_WINDOW);
		waveInPrepareHeader(hWaveIn , &whdr , sizeof(WAVEHDR));
		return 0;
//	case MM_WOM_OPEN:
//		EnableWindow(GetDlgItem(hWnd , IDB_PLAY) , FALSE);
//		EnableWindow(GetDlgItem(hWnd , IDB_REC) , FALSE);
//		waveOutWrite(hWaveOut , &whdr , sizeof(WAVEHDR));
//		return 0;
//	case MM_WOM_DONE:
//		waveOutClose(hWaveOut);
//		EnableWindow(GetDlgItem(hWnd , IDB_PLAY) , TRUE);
//		EnableWindow(GetDlgItem(hWnd , IDB_REC) , TRUE);
//		return 0;
//	case MM_WOM_CLOSE:
//		waveOutUnprepareHeader(hWaveOut , &whdr , sizeof(WAVEHDR));
//		return 0;
	}
	return DefWindowProc(hWnd , msg , wp , lp);
}


int WINAPI WinMain(HINSTANCE hInstance , HINSTANCE hPrevInstance ,
			PSTR lpCmdLine , int nCmdShow ) {
	HWND hwnd;
	MSG msg;
	WNDCLASS winc;

	winc.style		= CS_HREDRAW | CS_VREDRAW;
	winc.lpfnWndProc	= WndProc;
	winc.cbClsExtra		= 0;
	winc.cbWndExtra		= DLGWINDOWEXTRA;
	winc.hInstance		= hInstance;
	winc.hIcon		= LoadIcon(NULL , IDI_APPLICATION);
	winc.hCursor		= LoadCursor(NULL , IDC_ARROW);
	winc.hbrBackground	= (HBRUSH)CreateSolidBrush(GetSysColor(COLOR_MENU));
	winc.lpszMenuName	= NULL;
	winc.lpszClassName	= TEXT("KITTY");

	if (!RegisterClass(&winc)) return -1;

	hwnd = CreateDialog(hInstance , TEXT("KITTY") , 0 , NULL);

	if (hwnd == NULL) return -1;

	while(GetMessage(&msg , NULL , 0 , 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}